#ifndef _FCNS_H_
#define _FCNS_H_

#include "vardec.h"
#include "net.h"


/* File: bbs.c */

int checkpw();
void end_bbs(int lev);
void sublist();
void dirlist();
void text_edit();
void send_email();
void mainmenu();
void dlmainmenu();
int date_changed();
void print_local_file(char *ss, char *ss1);
void getcaller();
void gotcaller(unsigned int ms, unsigned int cs);
void main(int argc, char *argv[]);


/* File: bbsutl.c */

void far *malloca(unsigned long nbytes);
void stuff_in(char *s, char *s1, char *f1, char *f2, char *f3, char *f4, char *f5);
void copy_line(char *s, char *b, long *ptr, long len);
char *mmkey(int dl);
void inli(char *s, char *rollover, int maxlen, int crend);
int so();
int cs();
int lcs();
void checka(int *abort, int *next);
void pla(char *s, int *abort);
char *ctim(double d);
int sysop2();
void reqchat();
void yourinfo();
void upload_post();
int checkcomp(char *s);


/* File: bbsutl1.c */

int ok_local();
int finduser1(char *sx);
void sl1(int cmd,char *s);
void sysopchar(char *s);
void sysoplog(char *s);
void ssm(int un, int sy, char *s);
void rsm(int un, userrec *u);
void show_chains(int *mapp, int *map);
void run_chain(int cn);
void do_chains();


/* File: com.c */

int check_comport(int pn);
void savel(char *cl, char *atr, char *xl, char *cc);
void restorel(char *cl, char *atr, char *xl, char *cc);
void ptime();
void reprint();
void print_help(int n);
void setbeep(int i);
void far interrupt async_isr ();
void outcomch(char ch);
char peek1c();
char get1c();
int comhit();
void dump();
void set_baud(unsigned int rate);
void initport(int port_num);
void closeport();
void dtr(int i);
void rts(int i);
int cdet();
void checkhangup();
void addto(char *s, int i);
void makeansi(unsigned char attr, char *s, int forceit);
void setfgc(int i);
void setbgc(int i);
void execute_ansi();
void outchr(char c);
void outstr(char *s);
void nl();
void backspace();
void setc(unsigned char ch);
void pausescr();
void npr(char *fmt, ...);
void pl(char *s);
int kbhitb();
int empty();
void skey1(char *ch);
char getchd();
char getchd1();
char inkey();
void mpl(int i);
char upcase(char ch);
unsigned char getkey();
void input1(char *s, int maxlen, int lc, int crend);
void input(char *s, int len);
void inputl(char *s, int len);
int yn();
int ny();
void ansic(int n);
char onek(char *s);
void prt(int i, char *s);


/* File: conio.c */

void my_video_int();
void set_global_handle(int i);
void global_char(char ch);
void movecsr(int x,int y);
int wherex();
int wherey();
void lf();
void cr();
void clrscrb();
void bs();
void out1chx(unsigned char ch);
void out1ch(unsigned char ch);
void outs(char *s);
void pr_wait(int i1);
void set_protect(int l);
void savescreen(screentype *s);
void restorescreen(screentype far *s);
void makewindow(int x, int y, int xlen, int ylen);
void editline(char *s, int len, int status, int *returncode, char *ss);
void val_cur_user();
void temp_cmd(char *s, int ccc);
char scan_to_char(unsigned char ch);
void alt_key(unsigned char ch);
void skey(char ch);
void tleft(int x);
void topscreen();
void tleft(int x);
void topscreen();
void two_way_chat(char *s, char *rollover, int maxlen, int crend);
void chat1(char *chatline, int two_way);
void set_autoval(int n);


/* File: connect1.c */

void read_call_out_list();
void write_call_out_list();
void read_bbs_list();
void read_bbs_list_index();
net_system_list_rec *next_system(unsigned int ts);
void read_contacts();


/* File: extrn.c */

unsigned char getkeyext();
void cd_to(char *s);
void get_dir(char *s, int be);
void initporte(int port_num);
int do_it(char *cl);
int do_remote(char *s, int ccc);
void checka1();
void checka2();
void run_external(char *s);
int run_external1(char *s);
void outdosstr(char *s);
int do_external(char *s, int enab);
int full_external(char *s, int ctc, int ccc);
void alf(int f, char *s);
char *create_chain_file(char *fn);


/* File: modem.c */

void pr1(unsigned char *s);
void get_modem_line(char *s, double d, int allowa);
void do_result(result_info *ri);
void process_full_result(char *s);
int mode_switch(double d, int allowa);
void holdphone(int d);
void imodem(int x);
void answer_phone();


/* File: msgbase.c */

void describe_area_code(int areacode, char *description);
void setorigin(int sysnum, int usernum);
int okfsed();
void remove_link(messagerec *m1, char *aux);
int open_file(char *fn);
void savefile(char *b, long l1, messagerec *m1, char *aux);
char *readfile(messagerec *m1, char *aux, long *l);
void change_storage(messagerec *oldm, char *olda, messagerec *newm, char *newa);
void load_workspace(char *fnx, int no_edit);
void osan(char *s, int *abort, int *next);
void addline(char *b, char *s, long *ll);
void stuff(char *s, char *old, char *new);
void inmsg(messagerec *m1, char *title, int *anony, int needtitle, char *aux, int fsed);
int forwardm(unsigned short *u, unsigned short *s);
void sendout_email(char *title, messagerec *msg, int anony, unsigned un, unsigned sy, int an);
void email(unsigned short un, unsigned short sy, int forceit, int anony);
void imail(unsigned short u, unsigned short s);
void iscan(int b);
void iscan_hash(int b);
void savebase();
void plan(char *s, int *abort, int *next);
void read_message1(messagerec *m1, char an, int readit, int *next, char *fn);
int printfile(char *fn);
void read_message(int n, int *next, int *val);
void lineadd(messagerec *m1, char *sx, char *aux);
void delete(int mn);


/* File: msgbase1.c */

void send_net_post(postrec *p, unsigned int type, char *extra);
void post();
void extract_out(char *b, long len, char *title);
void grab_user_name(messagerec *m, char *fn);
void quote_message(messagerec *m1, char *aux);
void scan(int msgnum, int optype, int *nextsub);
void qscan(int bn, int *ns);
void nscan(int ss);
void scan2();
void printmenu(int i);
void delmail(int f, int loc);
void readmail();
void remove_post();
int external_edit(char *fn1, char *direc, int ednum, int numlines);


/* File: netsup.c */

void checkup(struct ftime *f1, struct ftime *f2, int *tf);
int check_bbsdata();
int checkup2(struct ftime *f, char *x);
int check_bbsdata();
void cleanup_net();
unsigned int max_speed(int s1, int s2);
void do_callout(int sn);
int ok_to_call(int i);
void fixup_long(long *f, long l);
void attempt_callout();
void force_callout();
void print_pending_list();


/* File: shrink.c */

int restore_data(char *s);
void save_state(char *s, int state,int ctc);
void do_it_1(char *cl);
void shrink_out(char *command, int state, int intercept,int ctc,int ccc);


/* File: sr.c */

char *stripfn(char *fn);
void stripfn1(char *fn);
void calc_CRC(unsigned char b);
char gettimeout(double d, int *abort);
int extern_prot(int pn, char *fn1, int sending);
int ok_prot(int pn, xfertype xt);
char *prot_name(int pn);
int get_protocol(xfertype xt);
void ascii_send(char *fn, int *sent, double *percent);
void send_file(char *fn, int *sent, int *abort, char ft, char *sfn, int dn, long fs);
void receive_file(char *fn, int *received, char *ft, char *sfn, int dn);
char end_batch1();
void endbatch();


/* File: utility.c */

void reset_act_sl();
void remove_from_temp(char *fn, char *dir, int po);
void check_event();
void run_event();
double freek(int dr);
unsigned char years_old(unsigned char m, unsigned char d, unsigned char y);
void itimer();
double timer();
long timer1();
int sysop1();
int okansi();
void frequent_init();
void read_in_file(char *fn, messagerec *m, int maxary);
void far *mallocx(unsigned long l);
void fix_user_rec(userrec *u);
void close_user();
void open_user();
int number_userrecs();
void read_user(unsigned int un, userrec *u);
void write_user(unsigned int un, userrec *u);
void save_status();
double ratio();
double post_ratio();
char *nam(userrec *u1, unsigned int un);
char *nam1(userrec *u1, unsigned int un, unsigned int sy);
double nsl();
char *date();
char *times();
unsigned int finduser(char *s);
void changedsl();
void isr(int un, char *name);
void dsr(char *name);
void wait(double d);
void wait1(long l);
double freek1(char *s);
int exist(char *s);
void add_ass(int i, char *ss);


/* File: xfer.c */

int check_batch_queue(char *fn);
int check_ul_event(int dn, uploadsrec *u);
int okfn(char *s);
char *make_abs_cmd(char *out);
void get_arc_cmd(char *out, char *arcfn, int cmd, char *ofn);
int list_arc_out(char *fn, char *dir);
int ratio_ok();
int dcs();
void dliscan1(int dn);
void dliscan_hash(int dn);
void dliscan();
void closedl();
void add_extended_description(char *fn, char *desc);
void delete_extended_description(char *fn);
char *read_extended_description(char *fn);
void print_extended(char *fn, int *abort, unsigned char numlist, int indent);
void modify_extended_description(char **sss);
void align(char *s);
int compare(char *s1, char *s2);
void printinfo(uploadsrec *u, int *abort);
void printtitle(int *abort);
void file_mask(char *s);
void listfiles();
void nscandir(int d, int *abort,int title);
void nscanall();
void searchall();
int recno(char *s);
int nrecno(char *s,int i1);
int printfileinfo(uploadsrec *u, int dn);
void upload(int dn);
int try_to_download(char *s, int dn,int title);
void download();
void setldate();
void finddescription();
void arc_l();
void yourinfodl();
void l_config_nscan();
void config_nscan();
void xfer_defaults();
void removefile();


/* File: batch.c */

void listbatch();
void delbatch(int i);
void downloaded(char *fn);
void didnt_upload(int ind);
void uploaded(char *fn);
void ymbatchdl(int had);
void handle_dszline(char *l);
double ratio1(long a);
void make_ul_batch_list(char *listfn);
void make_dl_batch_list(char *listfn);
void run_cmd(char *cmdln, char *downlist, char *uplist, char *dl, int had);
void process_dszlog();
void dszbatchdl(int had, char *cmdln, char *desc);
void dszbatchul(int had, char *cmdln, char *desc);
void bibatch(int had, int pn);
void batchdl();


/* File: chnedit.c */

void chaindata(int n, char *s);
void showchains();
void modify_chain(int n);
void insert_chain(int n);
void delete_chain(int n);
void chainedit();


/* File: defaults.c */

void select_editor();
void print_cur_stat();
char *cn(char c);
char *describe(char col);
void color_list();
void change_colors();
void l_config_qscan();
void config_qscan();
void list_macro(unsigned char *s);
void make_macros();
void input_pw1();
void modify_mailbox();
void optional_lines();
void enter_regnum();
void defaults();


/* File: diredit.c */

void dirdata(int n, char *s);
void showdirs();
void modify_dir(int n);
void insert_dir(int n);
void delete_dir(int n);
void dlboardedit();


/* File: gfiles.c */

char *get_file(char *fn, long *len);
gfilerec *read_sec(int sn, int *nf);
void list_sec(int *map, int nmap);
void list_gfiles(gfilerec *g, int nf);
void gfile_sec(int sn);
void gfiles();


/* File: gfledit.c */

void gfiledata(int n, char *s);
void showsec();
int exist_dir(char *s);
void modify_sec(int n);
void insert_sec(int n);
void delete_sec(int n);
void gfileedit();
int fill_sec(int sn);


/* File: lilo.c */

int check_ansi();
void getuser();
void logon();
void logoff();


/* File: misccmd.c */

void read_automessage();
void write_automessage1();
void write_automessage();
void bbslist();
void kill_old_email();
void list_users();
void print_quest(int f, int mapp, int map[21]);
int print_question(int f, int i, int ii);
void vote_question(int f, int i, int ii);
void vote();


/* File: multmail.c */

void multimail(int *un, int numu);
int oneuser();
void add_list(int *un, int *numu, int maxu, int allowdup);
void slash_e();


/* File: newuser.c */

int check_name(char *nn);
void input_name();
void input_realname();
void input_address();
void input_citystate();
void input_callsign();
void input_phone();
void input_sex();
void input_age(userrec *u);
void input_comptype();
void input_screensize();
void input_pw();
void input_ansistat();
void newuser();


/* File: srrcv.c */

char modemkey(int *tout);
int receive_block(char *b, unsigned char *bln, int ucrc);
void xymodem_receive(char *fn, char *ft, int *received, int ucrc);


/* File: srsend.c */

void send_block(char *b, int type, int ucrc, char bn);
char send_b(int f, long pos, int type, char bn, int *ucrc, char *fn, int *terr, int *abort);
int okstart(int *ucrc, int *abort);
void xymodem_send(char *fn, int *sent, double *percent, char ft, int ucrc, int ym, int ymb);


/* File: subedit.c */

void boarddata(int n, char *s);
void showsubs();
void modify_sub(int n);
void insert_sub(int n);
void delete_sub(int n);
void boardedit();


/* File: sysopf.c */

void isr1(int un, char *name);
void reset_files();
void get_status();
void prstatus();
void valuser(int un);
void print_net_listing(unsigned int ss);
void read_new_stuff();
void mailr();
void chuser();
void zlog();
void beginday();


/* File: tedit.c */

struct line *read_file(char *fn, int *numlines);
void kill_file(struct line *topline);
void save_file(char *fn, struct line *topline);
int printl(int n, struct line *l);
void tedit(char *fn);


/* File: uedit.c */

void deluser(int un);
void print_data(int un, userrec *u, int lng);
int matchuser(int un);
void changeopt();
int matchuser(int un);
int match_user(userrec *u);
void changeopt();
void uedit(int usern, int other);


/* File: voteedit.c */

void print_quests(int f);
void set_question(int f, int ii);
void ivotes();
void voteprint();


/* File: xferovl.c */

void move_file();
int comparedl(uploadsrec *x, uploadsrec *y, int type);
void quicksort(int l,int r,int type);
void sortdir(int dn, int type);
void sort_all(int type);
void rename_file();
int upload_file(char *fn, int dn, char *desc);
int maybe_upload(char *fn, int dn, char *desc);
void upload_files(char *fn, int dn, int type);
int uploadall(int dn);


/* File: xfertmp.c */

long bad_filename(char *fn);
long check_for_files_zip(char *fn);
int check_for_files(char *fn);
void download_temp_arc();
void add_temp_arc();
void del_temp();
void list_temp_dir();
void temp_extract();
void list_temp_text();
void list_temp_arc();
void temporary_stuff();


/* File: xinit.c */

void init();

#endif
